import bsh.*;

import java.util.Vector;
import java.io.IOException;

/**
 *  Testing module
 */

public class callFromJava {

    public static void main( String argv[] ) {
        callFromJava me = new callFromJava();
        me.mymain ( argv ) ;

    }

    public void mymain ( String argv[] ) {

        try {
//            String test = "Sum=answered(U);Sum=a+b;"; //  tests undefined function
//            String test ="Sum=badsyntax();";  // tests syntax error in library
//            String test = "Sum=a-U;";   //  tests undefined variable U
//            String test = "Sum=a+b };Sum=a-b;";   //  tests syntax error in script
//            String test = "t=1; {int x=y+z;}  Sum=x;";
//            String test="Sum=answered(xx);";
//            String test = "z=3+4;\r\nSum=5+6;";
//            String test = "Sum=a+b";
//            String test = "Sum=numberanswered(a,b,c,d,e)";
//            String test = "Sum=isin(0,2,3,4,1,5);";

//            String test = "b=\"123456789\";Sum=b.substring(2)";
//            String test = "Sum=a-b;";   //  must be not strings
//            String test = "a=\"aaa\";b=\"bbb\";Sum=a+b;";
//            String test = "A=5;\r\nB=6;\nSum=A+B;";
//            String test = "Sum=A+B;";
//            String test = "a = java.lang.System.currentTimeMillis()";
//            String test = "System.out.print( System.currentTimeMillis() );";
//            String test = "Sum=new java.util.Date();";
//            String test ="Sum=U;";
//            String test = "import java.util.*;Date dd =new Date();Sum=dd;";
            String test = "//gettime();";

            Interpreter interpreter = new Interpreter();
            //  Add built-in functions; may need to modify path!
            try {
                interpreter.source( "/extra/sample.bsh");
            } catch (IOException oops) {
                System.out.print( oops.toString());
                return;
            }
            NameSpace nsp = interpreter.getNameSpace();
            //  Register Listener for variables which are Set
            val vadded = new val ();
            nsp.addVariableAddedListener( vadded );
            //  Register Listener for providing Values
            vg  vgetter = new vg ();
            nsp.setVariableGetter(vgetter);
            
            interpreter.eval(test);
            Vector whatwasadded = vadded.whatwasadded;
            //  vadded.whatwasadded has names of variables that were set
            Object o = interpreter.get("Sum");
            System.out.print (o);
        } catch (EvalError evalError) {
            System.out.print ( evalError.toString());
        } catch ( Throwable e ) {

        }
    }

}

/**
 * Listener records names of variables that have been assigned
 */

class val implements VariableAddedListener {
    Vector whatwasadded;

    public void nameAssigned(String name) {
        if ( whatwasadded == null )
            whatwasadded = new Vector();
        whatwasadded.add(name);
    }
}

/**
 * Looks up valuse in environment
 * If value is missing, returns long (0)
 * If present, returns double (value) or String if not numeric
 */

class vg implements VariableGetter {
    static int random = 5;

    public Object getExternalValue(String name) throws bsh.UtilEvalError {
        if ( "D".equals(name))  //  perfect at execution time
            return new Primitive ( (double) random++ );  //  defined variable
        if ( "X".equals(name))
            return Primitive.VOID;  //  undefined variable
        if ( "U".equals(name) ) //  to test undefined during Publish time
            throw new bsh.UtilEvalError ("Question '" + name +
                    "' not defined or misspelled " );
        //  This is great, except that if we're using System,
        //  it will fail.
        //  I could make an exception for System.
        //  What does it do with just Date?
        if ( true )
            return Primitive.VOID;
        //  Emulate what values might be
        if ( random++ % 2 == 1 )
            return new Primitive ( (long) 0 );
        else
            return new Primitive ( (double) random );
    }
}

